; marirc 3.0 scrambler bot
; Working game for irc channels modeled off of aol scramblers
; By Matt - <matt@liek.net>
; IRC - irc.semicolon-zero.com - #liek

;; Scramble - the dirty work
alias -l scramble {
  var %words = $1-
  var %i = 1
  while (%i <= $numtok(%words,32)) {
    var %word = $gettok(%words,%i,32)
    var %x = $len(%word)
    var %sword = $null
    while (%x > 0) {      
      var %ch = $rand(1,%x)
      var %sword = %sword $+ $mid(%word,%ch,1)
      %word = $removechar(%word,%ch) ; remchar - clear out used letter
      dec %x
    }
    var %scram = %scram %sword
    inc %i
  }
  return %scram
}

;; Show Scrambler Dialog
alias scram {
  if (!$dialog(scrambler)) {
    dialog -dm scrambler dlg_lscram
  }
}
;; Borrowed from vcv :)
alias removechar {
  return $left($1,$calc($2 - 1)) $+ $right($1,$calc($len($1) - $2))
}

;; Scrambler Dialog
dialog dlg_lscram {
  title "Liek Scrambler"
  size -1 -1 185 191
  option dbu
  combo 1, 60 40 60 12, size drop
  text "Liek Scrambler", 2, 1 1 183 8, center
  text "Log Files", 3, 61 32 59 8, center
  button "Add Log", 5, 44 54 37 12
  radio "Scrambler", 6, 38 12 50 10, group
  radio "Shout Out", 7, 104 13 50 10
  button "Remove Log", 8, 98 54 37 12
  edit "", 11, 34 70 50 10
  text "Word:", 12, 4 70 19 8
  edit "", 13, 34 88 50 10
  text "Channel:", 14, 4 88 23 9
  link "www.liek.net", 15, 149 181 34 8
  button "Exit", 16, 28 162 37 12, ok cancel
  button "Start Log", 29, 28 131 38 12
  button "End Game", 30, 73 131 37 12
  button "Display Scores", 31, 28 146 38 12
  button "Echo Scores", 32, 117 146 37 12
  edit "", 33, 125 70 48 10
  text "Hint Time:", 34, 95 71 31 8
  edit "", 35, 125 88 47 10
  text "Wait Time:", 36, 95 89 31 8
  edit "", 38, 125 105 47 10
  text "Winners:", 39, 95 106 31 8
  button "Skip Word", 40, 117 131 37 12
  check "Cap Each First Letter", 41, 3 106 70 8
  button "Advanced...", 42, 73 146 37 12
  button "Clear Scores", 43, 73 162 37 12
  edit "", 44, 2 179 142 11
  check "Remote", 45, 118 164 36 10
}

dialog new_table {
  title "Advanced Options"
  size -1 -1 186 87
  option dbu
  text "Liek Scrambler - Advanced Options", 1, 0 1 186 9, center
  text "Timeout:", 2, 2 19 51 9
  radio "Static Timer", 3, 1 32 41 9, group
  radio "Word Length", 4, 46 32 44 9
  radio "Character Length", 5, 93 33 52 8
  edit "", 6, 149 32 34 10
  text "Hint Settings:", 7, 2 45 51 9
  radio "Static Timer", 8, 2 58 40 9, group
  radio "Word Length", 9, 47 57 41 10
  radio "Character Length", 10, 93 58 51 10
  edit "", 11, 149 58 33 10
  button "Done", 12, 2 71 41 14, ok
  check "Enable", 13, 57 19 50 9
  check "Enable", 14, 57 45 51 9
}
