; marirc 3.1 event handlers
; Interface ripped from aol
; Center-align ripped from vcv
; By Matt - <matt@liek.net>
; IRC - irc.semicolon-zero.com - #liek

; Startup Proc
on 1:START: {
  hld colors
  hld preload
  echo $hget(colors,reg) -s $logo $scolor(reg) $+ Welcome to $hget(preload,name) $hget(preload,ver) by $hget(preload,creator)
  echo $hget(colors,reg) -s $logo $scolor(reg) $+ Loading Settings... 
  hld joinsync
  hdel -w joinsync *
  hsv joinsync
  echo $hget(colors,reg) -s $logo $scolor(reg) $+ Settings Loaded!
  echo $hget(colors,reg) -s $logo $scolor(reg) $+ Loading URL addon...  
  hld url
  echo $hget(colors,reg) -s $logo $scolor(reg) $+ URL Addon Loaded!
  echo $hget(colors,reg) -s $logo $scolor(reg) $+ Loading Away data...
  ladb
  echo $hget(colors,reg) -s $logo $scolor(reg) $+ Away data loaded!
  echo $hget(colors,reg) -s $logo $scolor(reg) $+ Check for updates at $hget(preload,url)
  var %load = $hget(preload,loads)
  inc %load 1
  ;hadd preload loads %load
  ;hsave -o preload data\preload.hash
  hdo preload loads %load
  echo $hget(colors,reg) -s $logo $scolor(reg) $+ You have loaded $hget(preload,name) %load time(s)! 
}

; Commands

;; $scolor - Get Script Colors
alias scolor {
  return  $+ $hget(colors,$1)
}

;; $logo - return logo :)
alias logo {
  return $scolor(logo) $+ $hget(preload,logo) $+ 
}

;; $sevent - return event prefix
alias sevent {
  return $hget(preload,event)
}

;; $spaces - Insert amount of spaces
alias spaces {
  return $str(  $+ $chr(32) ,$$1) 
}

;; /ecomc = Echo on ComChan ($1 - nick, $2 - text)
alias ecomc {
  var %ecomc  = 1
  :loop
  if ( %ecomc == $comchan($$1,0) ) { echo $comchan($$1,%ecomc) $2- | goto end }
  if ( %ecomc < $comchan($$1,0) ) { echo $comchan($$1,%ecomc) $2- }
  inc %ecomc 1
  goto loop
  :end
}

;; /recomc = Echo on ComChan 
; $1 = window, $2 - indent, $3- = text
alias recomc {
  var %ecomc = 1
  :loop
  if ( %ecomc == $comchan($$1,0) ) { recho $comchan($$1,%ecomc) $2 $3- | goto end }
  if ( %ecomc < $comchan($$1,0) ) { recho $comchan($$1,%ecomc) $2 $3- }
  inc %ecomc 1
  goto loop
  :end
}

;; /ecomci - Echo on comchan + indent ($1 - nick, $2 - text) 
alias ecomci {
  var %ecomc  = 1
  :loop
  if ( %ecomc == $comchan($$1,0) ) { cecho $comchan($$1,%ecomc) $2- | goto end }
  if ( %ecomc < $comchan($$1,0) ) { cecho $comchan($$1,%ecomc) $2- }
  inc %ecomc 1
  goto loop
  :end
}

; Channel Events
;; Commands

;;; /text - Modify Display of text
alias text {
  if ($1 == highlight) {
    if ($2 == on) {
      ;hadd preload highlight on
      ;hsave -o preload data\preload.hash
      hdo preload highlight on
      smsg Highlight enabled
    }
    elseif ($2 == off) {
      ;hadd preload highlight off
      ;hsave -o preload data\preload.hash
      hdo preload highlight off
      smsg Highlight disabled
    }
    elseif ($$2 == $null) {
      smsg Highlight is: $hget(preload,highlight)
    }
    else {
      errmsg /text - Highlight can only be 'on' or 'off'
    }
  }
  elseif ($1 == indent) {
    if (($2 == 0) || ($2 == off)) {
      ;hadd preload ident -2
      ;hsave -o preload data\preload.hash
      hdo preload ident off
      smsg Text indent disabled
    }
    elseif ($2 == $null) {
      smsg Text indent is: $hget(preload,ident)
    }
    else {
      ;hadd preload ident $2
      ;hsave -o preload data\preload.hash
      if ($2 !isnum 13-25) { 
        smsg /text indent - Indent must be in the range 13-25
      }
      else {
        hdo preload ident $2
        smsg Text indent set: $2 chars
      }
    }
  }
  elseif ($1 == timestamp) {
    if ($2 == on) {
      hdo preload tstamp on
      smsg Timestamp enabled
    }
    elseif ($2 == off) {
      hdo preload tstamp off
      smsg Timestamp disabled
    }
    else {
      smsg Timestamp is: $hget(preload,tstamp)
    }
  }
  elseif ($1 == color) {
    ;if (($3 == $null) || ($3 == $null)) {
    ;  errmsg /text - Invalid Parameters
    ;  goto end
    ;}
    if ($3 != $null) {
      if ($2 == nick) { hdo colors nick $$3 | smsg Set Nick color to: $$3 }
      elseif ($2 == mynick) { hdo colors mynick $$3 | smsg Set Your Nick color to: $$3 }
      elseif ($2 == text) { hdo colors text $$3 | smsg Set Text color to: $$3 }
      elseif ($2 == delim) { hdo colors delim $$3 | smsg Set Delimiter color to: $$3 }
      elseif ($2 == highlight) { hdo colors high $$3 | smsg Set highlight color to: $$3 }
      elseif ($2 == reg) { hdo colors reg $$3 | smsg Set regular color to: $$3 }
      elseif ($2 == prefix) { hdo colors prefix $$3 | smsg Set Prefix color to: $$3 }
      elseif ($2 == timestamp) { hdo colors timestamp $$3 | smsg Set timestamp color to: $$3 }
      elseif ($2 == event) { hdo colors event $$3 | smsg Set event color to: $$3 }
      elseif ($2 == kick) { hdo colors kick $$3 | smsg Set kick color to: $$3 }
      elseif ($2 == mode) { hdo colors mode $$3 | smsg Set mode color to: $$3 }
      elseif ($2 == join) { hdo colors join $$3 | smsg Set join/part/quit color to: $$3 }
      elseif ($2 == topic) { hdo colors topic $$3 | smsg Set topic color to: $$3 }
      elseif ($2 == address) { hdo colors address $$3 | smsg Set address color to: $$3 }
      elseif ($2 == nickset) { hdo colors nickc $$3 | smsg Set NickSet color to: $$3 }
      elseif ($2 == kickmsg) { hdo colors kickmsg $$3 | smsg Set kick message color to: $$3 }
      elseif ($2 == modestr) { hdo colors modestr $$3 | smsg Set mode string color to: $$3 }
      elseif ($2 == topicstr) { hdo colors topicstr $$3 | smsg Set topic string color to: $$3 }
      elseif ($2 == opnick) { hdo colors opnick $$3 | smsg Set opnick color to: $$3 | updatenicklists }
      elseif ($2 == hnick) { hdo colors hnick $$3 | smsg Set hnick color to: $$3 | updatenicklists }
      elseif ($2 == vnick) { hdo colors vnick $$3 | smsg Set vnick color to: $$3 | updatenicklists }
      elseif ($2 == regnick) { hdo colors regnick $$3 | smsg Set regnick color to: $$3 | updatenicklists }
      elseif ($2 == logo) { hdo colors logo $$3 | smsg Set logo color to: $$3 }
    }
    else { 
      smsg Set script colors ( /text color option colorcode )
      smsg Valid options: text, nick, mynick, delim, highlight, reg, prefix, timestamp, event, kick, mode, join, topic, address, nickset, kickmsg, modestr, topicstr, opnick, hnick, vnick, regnick, logo
    }
  }
  else {
    errmsg /text - Not a valid /text command
  }
}

;;; $fixcolors - Changes disable of colors - BROKEN
alias fixcolors {
  var %i = 1
  var %c.txt = $replace($1-,$chr(32),$chr(160))
  while (%i <= $len($1-)) {
    if ($mid($1-,%i,1) == ) {
      if ($mid($1-,$calc(%i + 1),1) !isnum) {

      }
    }
  }
}

;;; $replacepos - Replaces a position in a string with another string - BROKEN 
;;; $1 - text, $2 - position, , $3 - length, $4 - newstring
alias replacepos {
  var %r.txt = $replace($1-,$chr(32),$chr(160))
  var %len = $calc($3 - 1)
  if ($2 == 1) {
    var %r.str = $4 $+ $mid(%r.txt,$calc($2 + %len))
  }
  elseif ($calc($2 + %len) >= $len(%r.txt)) {
    var %r.str = $mid(%r.txt,1,$calc($2 - 1)) $+ $4
  }
  else {
    var %r.str = $mid(%r.txt,1,$calc($2 - 1)) $+ $4 $+ $mid(%r.txt,$calc($2 + $iif($3 <= $len($4),$4,$3)))
  }
  %r.str = $replace(%r.str,$chr(160),$chr(32))
  return %r.str
}


;;; /smsg - Echo script messages 
alias smsg {
  echo $hget(colors,text) -a $logo $1- 
}

;;; /cecho - Center Echo
alias cecho {
  ; $1 = window, $2 = text
  echo $hget(colors,text) -q $+ i $+ $calc($iif($hget(preload,ident) != off,$hget(preload,ident) + 2,0) $iif($hget(preload,tstamp) == on, + $len($timestamp) + 1,)) $1 $iif($hget(preload,tstamp) == on,$scolor(timestamp) $+ $timestamp $+ , ) $2-
  ;  echo -se echo $hget(colors,text) -q $+ i $+ $calc($hget(preload,ident) + 2 $iif($hget(preload,tstamp) == on, + $len($timestamp) + 1,)) $1 $iif($hget(preload,tstamp) == on,$scolor(timestamp) $+ $timestamp $+ , ) $2-
}

;;; /kecho - Center echo for kicks
alias kecho {
  ; $1 = window, $2 = text
  echo $hget(colors,kick) -q $+ i $+ $calc($iif($hget(preload,ident) != off,$hget(preload,ident) + 2,0) $iif($hget(preload,tstamp) == on, + $len($timestamp) + 1,)) $1 $iif($hget(preload,tstamp) == on,$scolor(timestamp) $+ $timestamp $+ , ) $2-
  ;  echo -se echo $hget(colors,text) -q $+ i $+ $calc($hget(preload,ident) + 2 $iif($hget(preload,tstamp) == on, + $len($timestamp) + 1,)) $1 $iif($hget(preload,tstamp) == on,$scolor(timestamp) $+ $timestamp $+ , ) $2-
}

;;; /mecho - Center echo for modesets
alias mecho {
  ; $1 = window, $2 = text
  echo $hget(colors,mode) -q $+ i $+ $calc($iif($hget(preload,ident) != off,$hget(preload,ident) + 2,0) $iif($hget(preload,tstamp) == on, + $len($timestamp) + 1,)) $1 $iif($hget(preload,tstamp) == on,$scolor(timestamp) $+ $timestamp $+ , ) $2-
  ;  echo -se echo $hget(colors,text) -q $+ i $+ $calc($hget(preload,ident) + 2 $iif($hget(preload,tstamp) == on, + $len($timestamp) + 1,)) $1 $iif($hget(preload,tstamp) == on,$scolor(timestamp) $+ $timestamp $+ , ) $2-
}

;; /jecho - Center echo for join/part/kick
alias jecho {
  ; $1 = window, $2 = text
  echo $hget(colors,join) -q $+ i $+ $calc($iif($hget(preload,ident) != off,$hget(preload,ident) + 2,0) $iif($hget(preload,tstamp) == on, + $len($timestamp) + 1,)) $1 $iif($hget(preload,tstamp) == on,$scolor(timestamp) $+ $timestamp $+ , ) $2-
  ;  echo -se echo $hget(colors,text) -q $+ i $+ $calc($hget(preload,ident) + 2 $iif($hget(preload,tstamp) == on, + $len($timestamp) + 1,)) $1 $iif($hget(preload,tstamp) == on,$scolor(timestamp) $+ $timestamp $+ , ) $2-
}

;; /techo - Center echo for topics
alias techo {
  ; $1 = window, $2 = text
  echo $hget(colors,topicstr) -q $+ i $+ $calc($iif($hget(preload,ident) != off,$hget(preload,ident) + 2,0) $iif($hget(preload,tstamp) == on, + $len($timestamp) + 1,)) $1 $iif($hget(preload,tstamp) == on,$scolor(timestamp) $+ $timestamp $+ , ) $2-
  ;  echo -se echo $hget(colors,text) -q $+ i $+ $calc($hget(preload,ident) + 2 $iif($hget(preload,tstamp) == on, + $len($timestamp) + 1,)) $1 $iif($hget(preload,tstamp) == on,$scolor(timestamp) $+ $timestamp $+ , ) $2-
}

;; /necho - Center echo for nick changes
alias necho {
  ; $1 = window, $2 = text
  echo $hget(colors,nickc) -q $+ i $+ $calc($iif($hget(preload,ident) != off,$hget(preload,ident) + 2,0) $iif($hget(preload,tstamp) == on, + $len($timestamp) + 1,)) $1 $iif($hget(preload,tstamp) == on,$scolor(timestamp) $+ $timestamp $+ , ) $2-
  ;  echo -se echo $hget(colors,text) -q $+ i $+ $calc($hget(preload,ident) + 2 $iif($hget(preload,tstamp) == on, + $len($timestamp) + 1,)) $1 $iif($hget(preload,tstamp) == on,$scolor(timestamp) $+ $timestamp $+ , ) $2-
}

;;; /recho - Regular Echo
alias recho {
  ; $1 = window, $2 - indent, $3- = text
  echo $hget(colors,text) -qi $+ $calc($2 $iif($hget(preload,tstamp) == on, + $len($timestamp) + 1,)) $1 $iif($hget(preload,tstamp) == on,$scolor(timestamp) $+ $timestamp $+ , ) $3-
}

;;; /rsecho - Regular Echo to Status (Stupid khaled make echo "Status window" valid)
alias rsecho {
  ; $1 - indent, $2- - text
  ;echo -a 
  echo $hget(colors,text) -seqi $+ $calc($1 $iif($hget(preload,tstamp) == on, + $len($timestamp) + 1,)) $iif($hget(preload,tstamp) == on,$scolor(timestamp) $+ $timestamp $+ , ) $2-
}

;; Text
on ^*:TEXT:*:#: {
  haltdef
  if ($nick isop $chan) { var %ovh = @ }
  if ($nick ishelp $chan) { var %ovh = %ovh $+ % }
  if ($nick isvo $chan) { var %ovh = %ovh $+ + }
  var %ident = $hget(preload,ident)
  if (%ident == off) { %txt.nick = $nick | %spacelen = 0 | goto echo }
  var %spacelen = $calc(%ident - $calc($len($nick) + $len(%ovh)))
  if (%spacelen < 0) {
    var %txt.nick = $left($nick,$calc($len($nick) + %spacelen))
  }
  else {
    var %txt.nick = $nick
  }
  :echo
  if (* $+ $me $+ * iswm $1-) {
    cecho $chan $spaces(%spacelen) $+ $scolor(prefix) $+ %ovh $+ $iif($hget(preload,highlight) == on,$scolor(high) $+ %txt.nick $+ ,$scolor(nick) $+ %txt.nick $+ ) $+ $scolor(delim) $+ : $1-
  }
  else {
    cecho $chan $spaces(%spacelen) $+ $scolor(prefix) $+ %ovh $+ $scolor(nick) $+ %txt.nick $+ $scolor(delim) $+ : $1-
  }
}

;; Actions
on ^*:ACTION:*:#: {
  haltdef
  if ($nick isop $chan) { var %ovh = @ }
  if ( $nick ishelp $chan) { var %ovh = %ovh $+ % }
  if ($nick isvo $chan) { var %ovh = %ovh $+ + }
  var %ident = $hget(preload,ident)
  if (%ident == off) { %txt.nick = $nick | %spacelen = 0 | goto echo }
  var %spacelen = $calc(%ident - $calc($len($nick) + $len(%ovh)))
  if (%spacelen < 0) {
    var %txt.nick = $left($nick,$calc($len($nick) + %spacelen))
  }
  else {
    var %txt.nick = $nick
  }
  :echo
  if (* $+ $me $+ * iswm $1-) {
    cecho $chan $spaces(%spacelen) $+ $scolor(prefix) $+ %ovh $+ $iif($hget(preload,highlight) == on,$scolor(high) $+ %txt.nick $+  $+ $spaces(1),$scolor(nick) $+ %txt.nick $+  $+ $spaces(1)) $+ $scolor(text) $1-
  }
  else {
    cecho $chan $spaces(%spacelen) $+ $scolor(prefix) $+ %ovh $+ $scolor(nick) $+ %txt.nick $+  $+ $spaces(2) $+ $1-
  }
}

;; Modesets
on ^*:RAWMODE:#: {
  haltdef
  var %txt.str = $sevent
  var %ident = $hget(preload,ident)
  if (%ident == off) { %spacelen = 0 | goto echo }  
  var %spacelen = $calc(%ident - $len(%txt.str))
  :echo
  mecho $chan $spaces(%spacelen) $+ $scolor(event) $+ %txt.str $+ $spaces(2) $+  $+ Modes $scolor(delim) $+ ' $+ $scolor(modestr) $+ $1- $+ $scolor(delim) $+ ' $+  were set by $nick
}

;;Topic
on ^*:TOPIC:#: {
  haltdef
  var %txt.str = $sevent
  var %ident = $hget(preload,ident)
  if (%ident == off) { %spacelen = 0 | goto echo } 
  var %spacelen = $calc(%ident - $len(%txt.str))
  :echo
  techo $chan $spaces(%spacelen) $+ $scolor(event) $+ %txt.str $+ $spaces(2) $+ $scolor(topic) $+ Topic was set by $nick to: $scolor(delim) $+ ' $+  $+ $1- $+ $scolor(delim) $+ '
}

RAW 332:*: { 
  if ($me ison $2) {
    var %txt.str = $sevent
    var %ident = $hget(preload,ident)
    if (%ident == off) { %spacelen = 0 | goto echo } 
    var %spacelen = $calc(%ident - $len(%txt.str))
    :echo
    techo $2 $spaces(%spacelen) $+ $scolor(event) $+ %txt.str $+ $spaces(2) $+ $scolor(topic) $+ Topic is $+ $scolor(delim) $+ : ' $+  $+ $3- $+ $scolor(delim) $+ '
    haltdef
  }
}

RAW 333:*: {
  if ($me ison $2) {
    var %txt.str = $sevent
    var %ident = $hget(preload,ident)
    if (%ident == off) { %spacelen = 0 | goto echo } 
    var %spacelen = $calc(%ident - $len(%txt.str))
    :echo
    techo $2 $spaces(%spacelen) $+ $scolor(event) $+ %txt.str $+ $spaces(2) $+ $scolor(topic) $+ Topic set by $3 on $asctime($4-,mm/dd/yy h:nn:ss tt)
    haltdef
  }
}

;; Channel Creation Time, join sync
RAW 329:*: {
  if ($hget(joinsync,$2 $+ $chr(44) $+ $cid) isnum) {
    var %txt.str = $sevent
    var %ident = $hget(preload,ident)
    if (%ident == off) { %spacelen = 0 | goto echo }
    var %spacelen = $calc(%ident - $len(%txt.str))
    :echo 
    jecho $2 $spaces(%spacelen) $+ $scolor(event) $+ %txt.str $+ $spaces(2) $+  $+ Channel created at $asctime($3,mm/dd/yy h:nn:ss tt)

    ; Calculate JOIN Sync
    var %synctime = $calc($ticks - $hget(joinsync,$2 $+ $chr(44) $+ $cid))

    var %txt.str = $sevent
    var %ident = $hget(preload,ident)
    if (%ident == off) { %spacelen = 0 | goto echo2 }
    var %spacelen = $calc(%ident - $len(%txt.str))
    :echo2
    jecho $2 $spaces(%spacelen) $+ $scolor(event) $+ %txt.str $+ $spaces(2) $+  $+ Join sync'd in %synctime $+ ms
    hdo joinsync $2 $+ $chr(44) $+ $cid done
  }
}

;;Nicknames
on ^*:NICK: {
  haltdef
  echo $hget(colors,text) -s  $iif($hget(preload,tstamp) == on,$scolor(timestamp) $+ $timestamp) $logo 12nickchange. $+ $nick 10 $+ ->12 $newnick
  var %no.chans = $chan(0), %chan = $null, %i = 1
  if ( $chan(0) == 0 ) { goto done }
  var %txt.str = $sevent
  var %ident = $hget(preload,ident)
  if (%ident == off) { %spacelen = 0 | goto next } 
  var %spacelen = $calc(%ident - $len(%txt.str))
  :next
  %chan = $chan(%i)
  if ($newnick ison %chan) {
    necho %chan $spaces(%spacelen) $+ $scolor(event) $+ %txt.str $+ $spaces(2) $+  $+ $nick is now known as $newnick
  }
  if (%i == %no.chans) { goto done }
  inc %i 1
  goto next
  :done
}

;;Join/part
on *^:JOIN:#: {
  if ($nick != $me) {
    var %txt.str = $sevent
    var %ident = $hget(preload,ident)
    if (%ident == off) { %spacelen = 0 | goto echo } 
    var %spacelen = $calc(%ident - $len(%txt.str))
    :echo    
    jecho $chan $spaces(%spacelen) $+ $scolor(event) $+ %txt.str $+ $spaces(2) $+  $+ $nick $scolor(delim) $+ ( $+ $scolor(address) $+ $address $+ $scolor(delim) $+ ) $+  joined
    ;var %cline = $fline($chan,$nick,1,1)
    cline -m $hget(colors,regnick) $chan $fline($chan,$nick,1,1)
  }
  else {
    .who $chan
    var %txt.str = $sevent
    var %ident = $hget(preload,ident)
    if (%ident == off) { %spacelen = 0 | goto echo } 
    var %spacelen = $calc(%ident - $len(%txt.str))
    :echo    
    jecho $chan $spaces(%spacelen) $+ $scolor(event) $+ %txt.str $+ $spaces(2) $+  $+ You have joined $chan
    if ($hget(joinsync,$chan $+ $chr(44) $+ $cid) !isnum) {
      hdo joinsync $chan $+ $chr(44) $+ $cid $ticks
    }
    cline -m $hget(colors,regnick) $chan $fline($chan,$nick,1,1)
  }
  haltdef
}
RAW 353:*: {
  if ($2 == $chr(61)) {
    var %names.chan = $3
    var %names.list = $4-
  }
  else {
    var %names.chan = $2
    var %names.list = $3-
  }
  if (%names.chan !ischan) return
  var %i = 1
  var %i.end = $numtok(%names.list,32)
  while (%i <= %i.end) {
    ;echo %names.chan $ifmatch
    var %n = $gettok(%names.list,%i,32)
    if ($left(%n,1) == @) {
      cline -m $hget(colors,opnick) %names.chan $fline(%names.chan,$right(%n,$calc($len(%n) - 1)),1,1)
    }
    elseif ($left(%n,1) == %) {
      cline -m $hget(colors,hnick) %names.chan $fline(%names.chan,$right(%n,$calc($len(%n) - 1)),1,1)
    }
    elseif ($left(%n,1) == +) {
      cline -m $hget(colors,vnick) %names.chan $fline(%names.chan,$right(%n,$calc($len(%n) - 1)),1,1)
    }
    else {
      ;echo -a $ifmatch
      ;echo -a $fline(%names.chan,%n,1,1)
      cline -m $hget(colors,regnick) %names.chan $fline(%names.chan,%n,1,1)
    }
    inc %i 1
  }
}

on *^:PART:#: {
  if ($nick != $me) {
    var %txt.str = $sevent
    var %ident = $hget(preload,ident)
    if (%ident == off) { %spacelen = 0 | goto echo } 
    var %spacelen = $calc(%ident - $len(%txt.str))
    :echo
    jecho $chan $spaces(%spacelen) $+ $scolor(event) $+ %txt.str $+ $spaces(2) $+  $+ $nick $scolor(delim) $+ ( $+ $scolor(address) $+ $address $+ $scolor(delim) $+ ) $+  has left $+ $iif($1- != $null,$scolor(delim) $+ : $1-,)
  }
  else {
    if ($hget(joinsync,$chan $+ $chr(44) $+ $cid) != $null) {
      hdl joinsync $chan $+ $chr(44) $+ $cid
    }
  }
  haltdef
}

;;Quit
on ^*:QUIT: {
  haltdef
  echo -s  $iif($hget(preload,tstamp) == on,$scolor(timestamp) $+ $timestamp) $logo 12 $+ $nick ( $+ $address $+ ) has Quit IRC:10 $1-
  var %no.chans = $chan(0), %chan = $null, %i = 1
  if ($chan(0) == 0) { goto done }
  var %txt.str = $sevent
  var %ident = $hget(preload,ident)
  if (%ident == off) { %spacelen = 0 | goto next } 
  var %spacelen = $calc(%ident - $len(%txt.str))
  :next
  %chan = $chan(%i)
  if ($nick ison %chan) {
    jecho %chan $spaces(%spacelen) $+ $scolor(event) $+ %txt.str $+ $spaces(2) $+  $+ $nick $+ $scolor(delim) ( $+ $scolor(address) $+ $address $+ $scolor(delim) $+ ) $+  has quit $+ $iif($1- != $null,$scolor(delim) $+ : $1-,)
  }
  if (%i == %no.chans) { goto done }
  inc %i 1
  goto next
  :done
}

;; Disconnect
on *:DISCONNECT: {
  hdel -w joinsync * $+ $chr(44) $+ $cid
  hsv joinsync
}

;;Kick
on ^*:KICK:#: {
  if ($knick == $me) {
    var %txt.str = $sevent
    var %ident = $hget(preload,ident)
    if (%ident == off) { %spacelen = 0 | goto echo } 
    var %spacelen = $calc(%ident - $len(%txt.str))
    :echo
    cecho $chan $spaces(%spacelen) $+ $scolor(event) $+ %txt.str $+ $spaces(2) $+  $+ You were kicked by $nick $+ $scolor(delim) ( $+ $scolor(reg) $1- $+ $scolor(delim) $+ )
    )
  }
  else {
    var %txt.str = $sevent
    var %ident = $hget(preload,ident)
    if (%ident == off) { %spacelen = 0 | goto echo } 
    var %spacelen = $calc(%ident - $len(%txt.str))
    :echo
    kecho $chan $spaces(%spacelen) $+ $scolor(event) $+ %txt.str $+ $spaces(2) $+  $+ $knick was kicked by $nick $+ $scolor(delim) ( $+ $scolor(kickmsg) $+ $1- $+ $scolor(delim) $+ )
  }
  haltdef
}

;; Op/Deop/Help/Dehelp/Voice/Devoice
on *:OP:#: {
  cline -m $hget(colors,opnick) $chan $fline($chan,$opnick,1,1)
}
on *:DEOP:#: {
  if ($opnick ishelp $chan) {
    cline -m $hget(colors,hnick) $chan $fline($chan,$opnick,1,1)
  }
  elseif ($opnick isvo $chan) {
    cline -m $hget(colors,vnick) $chan $fline($chan,$opnick,1,1)
  }
  else {
    cline -m $hget(colors,regnick) $chan $fline($chan,$opnick,1,1)
  }
}

on *:HELP:#: {
  if ($hnick !isop $chan) {
    cline -m $hget(colors,hnick) $chan $fline($chan,$hnick,1,1)
  }
}
on *:DEHELP:#: {
  if ($hnick isop $chan) {
    cline -m $hget(colors,opnick) $chan $fline($chan,$hnick,1,1)
  }
  elseif ($hnick isvo $chan) {
    cline -m $hget(colors,vnick) $chan $fline($chan,$hnick,1,1)
  }
  else {
    cline -m $hget(colors,regnick) $chan $fline($chan,$hnick,1,1)
  }
}

on *:VOICE:#: {
  if (($vnick !isop $chan) && ($vnick !ishelp $chan)) {
    cline -m $hget(colors,vnick) $chan $fline($chan,$vnick,1,1)
  }
}
on *:DEVOICE:#: {
  if ($vnick isop $chan) {
    cline -m $hget(colors,opnick) $chan $fline($chan,$vnick,1,1)
  }
  elseif ($vnick ishelp $chan) {
    cline -m $hget(colors,hnick) $chan $fline($chan,$vnick,1,1)
  }
  else {
    cline -m $hget(colors,regnick) $chan $fline($chan,$vnick,1,1)
  }
}

;Input
;;Channel
on *:INPUT:#: {
  if ($1 == $null) { goto noinp }
  if (/* iswm $1) { goto cmd }
  if (*: iswm $1) {  goto nickc }
  msg $active $1- | haltdef | goto end
  :noinp
  beep 1 | haltdef | goto end
  :cmd
  goto end
  :nickc
  haltdef
  var %gnick = $left($1,$calc($len($1) - 1))
  var %glen = $len(%gnick)
  var %gnick.on = 0
  var %gnick.s = $nick($chan,0)
  :cloop
  inc %gnick.on 1
  if ($left($nick($chan,%gnick.on),%glen) == %gnick) { 
    set %gnick.a  $addtok(%gnick.a,$nick($chan,%gnick.on),46)
  }
  if (%gnick.on == %gnick.s) { goto ncheck }
  goto cloop
  :ncheck
  if ($numtok(%gnick.a,46) == 1) { msg # ( $+ $gettok(%gnick.a,1,46) $+ ): $2- | unset %gnick.* | goto end }
  else {
    if (%gnick.a == $null) {
      msg # $1- | haltdef | goto end
    }
    set %gnick.chan $chan
    set %gnick.t $2- 
    Nick_Complete 
    goto end 
  }
  :end
}
;;; NickComplete Dialog
dialog Nick_Complete {
  size -1 -1 368 352
  title "Nick Complete"
  Edit "",  1,  81 18 268 24
  Text "Message:",  2,  2 19 76 23
  List  3,  59 75 232 180,sort
  Text "Nickname",  4,  59 57 231 18,center
  button "Send",  5,  1 286 130 33,ok
  button "Cancel",  7,  215 285 131 35,cancel
}

alias Nick_Complete {
  /dialog -ma Nick_Complete Nick_Complete
  did -a Nick_Complete 1 %gnick.t
  var %gnick.loop = 0
  :loop
  inc %gnick.loop 1
  did -a Nick_Complete 3 $gettok(%gnick.a,%gnick.loop,46)
  if (%gnick.loop == $numtok(%gnick.a,46)) {
    goto end
  }
  goto loop
  :end
}

on 1:dialog:Nick_Complete:sclick:5: {
  var %gnick.nick = $did(3).seltext
  if (%gnick.nick == $null) {
    var %gnick.notice = $input(No nickname selected!,4,MaRIRC 2.5)
    /halt
  }
  msg %gnick.chan ( $+ %gnick.nick $+ ): $did(1).text
  unset %gnick.*
}
on 1:dialog:Nick_Complete:sclick:7: {
  unset %gnick.*
}
on 1:dialog:Nick_Complete:dclick:3: {
  dialog -k Nick_Complete
}

;Message Events
;;Text
on ^*:TEXT:*:?: {
  if (($away) && ($hget(preload,awaylog) == on)) {
    ladb
    var %network = $network
    if (%network == $null) {
      %network = $server
    }
    var %checkallowed = $hget(awayallow,$nick $+ $chr(44) $+ %network)
    if (%checkallowed == $null) {
      haltdef
      var %amtmsgs = $hget(awaynicks,$nick $+ $chr(44) $+ %network)
      if (%amtmsgs == $null) {
        var %maxawaymsgs = $calc($hget(preload,maxawaymsgs) - 1)
        .msg $nick I am currently away ( $+ %away.reason $+ ). Your message has been logged. You may send %maxawaymsgs more message(s).
        ;hdo awaynicks $nick $+ , $+ %network %maxawaymsgs
        %amtmsgs = $calc(%maxawaymsgs + 1)
      }
      if (%amtmsgs > 0) {
        dec %amtmsgs 1
        hdo awaynicks $nick $+ $chr(44) $+ %network %amtmsgs
        write %data.dir $+ %network $+ .awy $ctime $nick $me PRIVMSG $1-
        hdo away %network %network
        set %away.msgs $true
      }
      goto end
    }
  }
  var %ident = $hget(preload,ident)
  if (%ident == off) { %spacelen = 0 | goto echo } 
  var %spacelen = $calc(%ident - $len($nick))
  if (%spacelen < 0) {
    var %txt.nick = $left($nick,$len($nick))
  }
  else {
    var %txt.nick = $nick
  }
  :echo
  cecho $nick $spaces(%spacelen) $+ $scolor(nick) $+ %txt.nick $+ $scolor(delim) $+ : $1-
  haltdef
  :end
}

;; Notices
on ^*:NOTICE:*:?: {
  if (($away) && ($hget(preload,awaylog) == on)) {
    ladb
    var %network = $network
    if (%network == $null) {
      %network = $server
    }
    var %checkallowed = $hget(awayallow,$nick $+ $chr(44) $+ %network)
    if (%checkallowed == $null) {
      haltdef
      var %amtmsgs = $hget(awaynicks,$nick $+ $chr(44) $+ %network)
      if (%amtmsgs == $null) {
        var %maxawaymsgs = $calc($hget(preload,maxawaymsgs) - 1)
        .notice $nick I am currently away ( $+ %away.reason $+ ). Your message has been logged. You may send %maxawaymsgs more message(s).
        ;hdo awaynicks $nick %maxawaymsgs
        %amtmsgs = $calc(%maxawaymsgs + 1)
      }
      if (%amtmsgs > 0) {
        dec %amtmsgs 1
        hdo awaynicks $nick $+ $chr(44) $+ %network %amtmsgs
        write %data.dir $+ %network $+ .awy $ctime $nick $me NOTICE $1-
        hdo away %network %network
        set %away.msgs $true
      }
    }
    goto end
  }
  var %txt = $scolor(delim) $+ [ $+ $scolor(nick) $+ $nick $+ $scolor(delim) $+ ]
  if ($cid == $activecid) {
    if ($window($active).type == status) {
      rsecho $calc($len($strip(%txt,burc)) + 1) %txt $1-
    }
    else {
      recho $active $calc($len($strip(%txt,burc)) + 1) %txt $1-
    }
  }
  else {
    rsecho $calc($len($strip(%txt,burc)) + 1) %txt $1-
  }
  haltdef
  :end
}

;; Channel Notices
on ^*:NOTICE:*:#: {
  haltdef
  if ($nick isop $chan) { var %ovh = @ }
  if ($nick ishelp $chan) { var %ovh = %ovh $+ % }
  if ($nick isvo $chan) { var %ovh = %ovh $+ + }
  var %txt = $scolor(delim) $+ [ $+ $scolor(prefix) $+ %ovh $+ $scolor(nick) $+ $nick $+ $scolor(mynick) $target $+ $scolor(delim) $+ ]
  recho $chan $calc($len($strip(%txt,burc)) + 1) %txt $1-
}

;;Actions
on ^*:ACTION:*:?: {
  if (($away) && ($hget(preload,awaylog) == on)) {
    ladb
    var %network = $network
    if (%network == $null) {
      %network = $server
    }
    var %checkallowed = $hget(awayallow,$nick $+ $chr(44) $+ %network)
    if (%checkallowed == $null) {
      haltdef
      var %amtmsgs = $hget(awaynicks,$nick $+ $chr(44) $+ %network)
      if (%amtmsgs == $null) {
        var %maxawaymsgs = $calc($hget(preload,maxawaymsgs) - 1)
        .msg $nick I am currently away ( $+ %away.reason $+ ). Your message has been logged. You may send %maxawaymsgs more message(s).
        ;hdo awaynicks $nick %maxawaymsgs
        %amtmsgs = $calc(%maxawaymsgs + 1)
      }
      if (%amtmsgs > 0) {
        dec %amtmsgs 1
        hdo awaynicks $nick $+ $chr(44) $+ %network %amtmsgs
        write %data.dir $+ %network $+ .awy $ctime $nick $me ACTION * $nick $1-
        hdo away %network %network
        set %away.msgs $true
      }
      goto end
    }
  }
  var %ident = $hget(preload,ident)
  if (%ident == off) { %spacelen = 0 | goto echo } 
  var %spacelen = $calc(%ident - $len($nick))
  if (%spacelen < 0) {
    var %txt.nick = $left($nick,$len($nick))
  }
  else {
    var %txt.nick = $nick
  }
  :echo
  cecho $nick $spaces(%spacelen) $+ $scolor(nick) $+ %txt.nick $+  $+ $chr(32) $+  $1-
  haltdef
  :end
}
;;Query Input
on *:INPUT:?: {
  if ($1 == $null) { goto noinp }
  if (/* iswm $1) { goto cmd }
  msg $active $1- | haltdef | goto end
  :noinp
  beep 1 | haltdef | goto end
  :cmd
  goto end
  :end
}

; Whois

;; Raw 311
RAW 311:*: {
  echo $hget(colors,text) -a $logo Whois for $2 $+ ! $+ $3 $+ @ $+ $4 ( $+ $scolor(reg) $+ $6- $+ )
  haltdef
}

RAW 319:*: {
  echo $hget(colors,text) -a $logo Channels: $3-
  haltdef
}

RAW 312:*: {
  echo $hget(colors,text) -a $logo Server: $3 ( $+ $scolor(reg) $+ $4- $+ )
  haltdef
}

RAW 313:*: {
  echo $hget(colors,text) -a $logo Status: IRC Operator ( $+ $scolor(reg) $+ Run and hide! $+ )
  haltdef
}

RAW 301:*: {
  if ($cid == $activecid) {
    echo $hget(colors,text) -a $logo $2 is away: $3-
  }
  else {
    echo $hget(colors,text) -s $logo $2 is away: $3-
  }
  haltdef
}

RAW 317:*: {
  echo $hget(colors,text) -a $logo Signon: $asctime($4)
  echo $hget(colors,text) -a $logo Idle: $duration($3)
  haltdef
}

RAW 318:*: {
  echo $hget(colors,text) -a $logo End of Whois
  haltdef
}

RAW 307:*: {
  echo $hget(colors,text) -a $logo $2-
  haltdef
}

RAW 320:*: {
  echo $hget(colors,text) -a $logo $2-
  haltdef
}

RAW 378:*: {
  echo $hget(colors,text) -a $logo $2-
  haltdef
}

RAW 401:*: {
  if ($activecid == $cid) {
    echo $hget(colors,text) -a $logo $2-
  }
  else {
    echo $hget(colors,text) -s $logo $2-
  }
  haltdef
}

; CTCP

CTCP *:*:?: {
  if ($1 == PING) {
    .ctcpreply $nick $1 $2-
    var %ltxt 
  }
  else {
    var %ltxt = $2-
  }
  if ($1 == DCC) {
    goto end
  }
  haltdef
  var %txt = $scolor(delim) $+ < $+ $scolor(nick) $+ $nick $+ $scolor(delim) $upper($1) $+ $scolor(delim) $+ >
  if ($cid == $activecid) {
    if ($window($active).type == status) {
      rsecho $calc($len($strip(%txt,burc)) + 1) %txt %ltxt
    }
    else {
      recho $active $calc($len($strip(%txt,burc)) + 1) %txt %ltxt
    }
  }
  else {
    rsecho $calc($len($strip(%txt,burc)) + 1) %txt %ltxt
  }
  :end
}

on *:CTCPREPLY:*: {
  haltdef
  if ($1 == PING) {
    var %ctcp.ping = $calc($ticks - $2)
    var %ltxt = %ctcp.ping $+ ms
  }
  else {
    var %ltxt = $2-
  }
  var %txt = $scolor(delim) $+ < $+ $scolor(nick) $+ $nick $+ $scolor(delim) $upper($1) $+ $scolor(text) Reply $+ $scolor(delim) $+ >
  if ($cid == $activecid) {
    if ($window($active).type == status) {
      rsecho $calc($len($strip(%txt,burc)) + 1) %txt %ltxt
    }
    else {
      recho $active $calc($len($strip(%txt,burc)) + 1) %txt %ltxt
    }
  }
  else {
    rsecho $calc($len($strip(%txt,burc)) + 1) %txt %ltxt
  }
}

;; Snotice
on ^*:SNOTICE:*: {
  ;var %txt = $scolor(delim) $+ $chr(91) $+ $scolor(nick) $+ $server $+ $scolor(delim) $+ $chr(93)
  var %txt = $scolor(delim) $+ [ $+ $scolor(nick) $+ $server $+ $scolor(delim) $+ ]
  ;echo -a %txt
  ;echo -a $calc($len($strip(%txt,burc)) + 1)
  rsecho $calc($len($strip(%txt,burc)) + 1) %txt $1-
  haltdef
}

; Menus
menu channel {
  Channel Modes: .channel
  Sys Info
  .Client: {
    msg $chan [Client Version:mIRC $version + $hget(preload,name) $hget(preload,ver) ( $+ $hget(preload,vertxt) $+ )]
  }
  .Uptime: /uptime
  Moo
  .System Stats: /stat
  .Dialup Stats: /connstat
  .Network Interfaces: /ni
  .Screen Stats: /screenstat
  .MBM: /mbm
  Channel info: /chaninfo $chan
}

menu menubar {
  Settings:
  .$iif($hget(preload,tstamp) == on,Turn Timestamp Off,Turn Timestamp On): {
    if ($hget(preload,tstamp) == on) {
      hdo preload tstamp off
    }
    else {
      hdo preload tstamp on
    }
  }
  .$iif($hget(preload,highlight) == on,Turn Nick Highlight Off,Turn Nick Highlight On): {
    if ($hget(preload,highlight) == on) {
      hdo preload highlight off
    }
    else {
      hdo preload highlight on
    }
  }
  .Indent:
  ..Turn Indent Off: {
    hdo preload ident off
  }
  ..Set Indent: {
    var %ide = $?="Set Indent to: (13-25 chars)"
    if (%ide isnum 13-25) {
      hdo preload ident %ide
    }
  }
  .$iif($hget(preload,awaylog) == on,Turn Away Log Off,Turn Away Log On): {
    if ($hget(preload,awaylog) == on) {
      hdo preload awaylog off
    }
    else {
      hdo preload awaylog on
    }
  }
  .Set Max Away Messages: {
    var %ide = $?="Set max away messages to: (1 more more)"
    if (%ide isnum 1-) {
      hdo preload maxawaymsgs %ide
    }
  }
  Moo
  .System Stats: /statself
  .Dialup Stats: /connstatself
  .Network Interfaces: /niself
  .Screen Stats: /screenstatself
  .MBM: /mbmself
}

menu nicklist {
  Query: /query $$1
  Whois: /whois $$1
  Info: /uwho $$1
  -
  Control:
  .Ignore:/ignore $$1 1
  .Unignore:/ignore -r $$1 1
  .Op:/mode # +ooo $$1 $2 $3
  .Deop:/mode # -ooo $$1 $2 $3
  .Voice:/mode # +vvv $$1 $2 $3
  .Devoice:/mode # -vvv $$1 $2 $3
  .Kick:/kick # $$1 $read(%data.dir $+ kicks.txt)
  .Kick (why):/kick # $$1 $$?="Reason:"
  .Ban:/ban $$1 3
  .Ban, Kick:/ban $$1 3 | .timer 1 1 /kick # $$1 $read(%data.dir $+ kicks.txt)
  .Ban, Kick (why):/ban $$1 3 | .timer 1 1 /kick # $$1 $$?="Reason:"
  CTCP
  .Ping:/ctcp $$1 ping
  .Time:/ctcp $$1 time
  .Version:/ctcp $$1 version
  DCC
  .Send:/dcc send $$1
  .Chat:/dcc chat $$1
  -
  Slap!:/me slaps $$1 around a bit with a bug free copy of Bersirc..... not
  Trout: /me slaps $$1 around a bit with a large trout
}

menu chat {
  Info:/uwho $$1
  Whois:/whois $$1
  -
  Ignore:/ignore $$1 1 | /closemsg $$1
  -
  CTCP
  .Ping:/ctcp $$1 ping
  .Time:/ctcp $$1 time
  .Version:/ctcp $$1 version
  DCC
  .Send:/dcc send $$1
  .Chat:/dcc chat $$1
}

menu status {
  Server
  .Lusers:/lusers
  .Motd:/motd
  .Time:/time
  .Away
  ..Set Away...:/away $$?="Enter your away message:"
  ..Set Back:/back
  .List Channels:/list
  -
  Quit IRC:/quit Leaving
}
